#+begin_src emacs-lisp
(defun +org-habit-graph-on-own-line (graph)
    "Place org habit consitency graph below the habit."
    (add-text-properties (line-beginning-position) (line-end-position)
                         `(display ,(concat (when-let ((icon (car (org-agenda-get-category-icon
                                                                   (org-agenda-get-category)))))

                                              (format " %s " icon))
                                            (string-trim-left (thing-at-point 'line))
                                            (make-string (or org-habit-graph-column 0) ? )
                                            (string-trim-right
                                             (propertize graph 'display '(height (+ 1))
                                                         'mouse-face 'inherit))))))

(defun +org-habit-insert-consistency-graphs (&optional line)
  "Insert consistency graph for any habitual tasks."
  (let ((inhibit-read-only t)
        (buffer-invisibility-spec '(org-link))
        (moment (org-time-subtract nil
                                   (* 3600 org-extend-today-until))))
    (save-excursion
      (goto-char (if line (point-at-bol) (point-min)))
      (while (not (eobp))
        (let ((habit (get-text-property (point) 'org-habit-p)))
          (when habit
            (let ((graph (org-habit-build-graph
                          habit
                          (time-subtract moment (days-to-time org-habit-preceding-days))
                          moment
                          (time-add moment (days-to-time org-habit-following-days)))))
              (+org-habit-graph-on-own-line graph))))
        (forward-line)))))

(advice-add #'org-habit-insert-consistency-graphs
            :override #'+org-habit-insert-consistency-graphs)
#+end_src
